/*
Author: Kulverstukas
Website: http://9v.lt
Shouts: Evilzone.org; programisiai.lt;
 */

#include <stdio.h>
#include <string>
#include <windows.h>
#include <winerror.h>
#include <winreg.h>
#include <objidl.h>   /* For IPersistFile */
#include <shlobj.h>   /* For IShellLink */

using namespace std;

void getProgramName(char*progName, char*res);
void printHelp(char*programName);
void addToRegistry(char*argv0);
void removeFromRegistry();
void openTarget(char * filePath);

int main(int argc, char * argv[]) {
    if ((argc > 1) && (argc < 4)) {
        if ((strcmp(argv[1], "help") == 0) || (strcmp(argv[1], "h") == 0)) {
            printHelp(argv[0]);
        } else if ((strcmp(argv[1], "add") == 0) || (strcmp(argv[1], "-a") == 0)) {
            addToRegistry(argv[0]);
        } else if ((strcmp(argv[1], "remove") == 0) || (strcmp(argv[1], "-r") == 0)) {
            removeFromRegistry();
        } else if ((strcmp(argv[1], "open") == 0) || (strcmp(argv[1], "-o") == 0)) {
            openTarget(argv[2]);
        } else {
            printf("Wrong arguments given...\n");
//            getchar();
        }
    } else {
        printf("Wrong number of arguments given...\n\nUsage:\n");
        printHelp(argv[0]);
    }
    return 0;
}

void printHelp(char * progPath) {
    char progName[255];
    getProgramName(progPath, progName);
    printf("Opens folder where a shortcut points to;\nKulverstukas, http://9v.lt\n");
    printf("%s [add] [remove] [open lnk_file]\n", progName);
    printf("    add -- to install a registry key\n" \
           "           for using the program.\n");
    printf("    remove -- to uninstall from the registry.\n");
    printf("    open -- to open a folder where the LNK file points to.\n");
//    getchar();
}

void getProgramName(char * progName, char * res) {
    int i;
    int argLen = strlen(progName) - 1;
    int slashPos = 0;
    int counter = 0;
    // this steps through each char checking if it's a slash
    // stores slash position for later use
    // and determine how many chars are there from last found slash to end of str
    for (i = 0; i <= argLen; i++) {
        char c = progName[i];
        counter++;
        if ((c == 47) || (c == 92)) {
            slashPos = i;
            counter = 0;
        }
    }
    slashPos++;
    int src = slashPos;
    // copy chars from last found slash to the end
    for (i = 0; i <= counter; i++) {
        res[i] = progName[src];
        src++;
    }
    res[i] = '\0';
}

void addToRegistry(char * argv0) {
    HKEY keyHandle;
    LONG exists;
    exists = RegOpenKeyEx(HKEY_CLASSES_ROOT, TEXT("lnkfile\\shell\\Find target\\command"), 0, KEY_READ, &keyHandle);
    if (exists != ERROR_SUCCESS) { // key does not exist. Install it.
        LONG created;
        created = RegCreateKeyEx(HKEY_CLASSES_ROOT, TEXT("lnkfile\\shell\\Find target\\command"), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &keyHandle, NULL);
        if (created == 0) {
            LONG valueSet;
            char cmdLine[255];
            strcpy(cmdLine, argv0);
            strcat(cmdLine, " open \"%1\"");
            valueSet = RegSetValueEx(keyHandle, NULL, 0, REG_SZ, (LPBYTE)cmdLine, strlen(cmdLine)*sizeof(char));
            if (valueSet == 0) {
                printf("Successfully installed!\n");
//                getchar();
            } else {
                printf("Something went wrong setting a value.\nError code: %d\n", valueSet);
                RegCloseKey(keyHandle);
//                getchar();
                exit(1);
            }
        } else {
            printf("Something went wrong creating a registry entry.\nError code: %d\n", created);
            RegCloseKey(keyHandle);
//            getchar();
            exit(1);
        }
    } else { // key does exist. Do nothing.
        printf("Program already installed...\n");
//        getchar();
    }
    RegCloseKey(keyHandle);
}

void removeFromRegistry() {
    HKEY keyHandle;
    LONG exists;
    exists = RegOpenKeyEx(HKEY_CLASSES_ROOT, TEXT("lnkfile\\shell\\Find target\\command"), 0, KEY_ALL_ACCESS, &keyHandle);
    if (exists != ERROR_SUCCESS) { // key does not exist. Do nothing.
        printf("Key does not seem to exist...\n");
//        getchar();
    } else { // key does exist. Delete it.
        HKEY key;
        RegOpenKeyEx(HKEY_CLASSES_ROOT, TEXT("lnkfile\\shell\\Find target\\"), 0, KEY_ALL_ACCESS, &key);
        LONG removed;
        removed = RegDeleteKey(key, TEXT("command"));
        RegCloseKey(key);
        RegOpenKeyEx(HKEY_CLASSES_ROOT, TEXT("lnkfile\\shell"), 0, KEY_ALL_ACCESS, &key);
        removed = RegDeleteKey(key, TEXT("Find target"));
        RegCloseKey(key);
        RegOpenKeyEx(HKEY_CLASSES_ROOT, TEXT("lnkfile"), 0, KEY_ALL_ACCESS, &key);
        removed = RegDeleteKey(key, TEXT("shell"));
        RegCloseKey(key);
        if (removed == 0) {
            printf("Entry removed from registry...\n");
//            getchar();
        } else {
            printf("Something went wrong deleting a registry entry.\nError code: %d\n", removed);
            RegCloseKey(keyHandle);
//            getchar();
            exit(1);
        }
    }
    RegCloseKey(keyHandle);
}

void openTarget(char * filePath) {
    IShellLinkA* psl;
    CoInitialize(0);
    char * target = new char[MAX_PATH];
    // convert string to widestring
    string str = filePath;
    wstring wideFilePath;
    wideFilePath.assign(str.begin(), str.end());

    HRESULT hr = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*) &psl);

    if (SUCCEEDED(hr)) {
        IPersistFile* ppf;
        hr = psl->QueryInterface( IID_IPersistFile, (LPVOID *) &ppf);
        if (SUCCEEDED(hr)) {
            hr = ppf->Load(wideFilePath.c_str(), STGM_READ);
            if (SUCCEEDED(hr)) {
                psl->GetPath(target, MAX_PATH, 0, SLGP_RAWPATH);
            }
        }
    }
    string dir;
    string tmp = target;
    const size_t lastSlash = tmp.rfind('\\');
    if (string::npos != lastSlash) {
        dir = tmp.substr(0, lastSlash);
    }
    dir = "explorer.exe "+dir;
    char * command = (char *)dir.c_str();
    system(command);
}
